#include <iostream>

#include "shader/glhandle.h"

using namespace std;

void GLHandleObj::reset() { handle = 0; }

void GLHandleObj::destroy() {
	if (handle) glDeleteObjectARB(handle);
	handle = 0;
}

//static 'cuz we wanna handle any handle, not just our own objects
bool GLHandleObj::printHandleLog(GLhandleARB handle) {
	cerr << "log:" << endl;

	GLsizei charsWritten  = 0;
	char *infoLog;

	GLint infologLength = 0;
	glGetObjectParameterivARB(handle, GL_OBJECT_INFO_LOG_LENGTH_ARB, &infologLength);

	if (infologLength <= 0) {
		cerr << "none" << endl;
		return true;
	}

	infoLog = new char[infologLength];
	if (!infoLog) {
		cerr << "failed to alloc text buffer!" << endl;
		return false;
	}

	glGetInfoLogARB(handle, infologLength, &charsWritten, infoLog);
	cerr << infoLog << endl;

	delete infoLog;
	return true;
}
