#include <iostream>

#include "base/opengl.h"	//load_ext
#include "shader/shaderext.h"

using namespace std;

bool found_GL_ARB_shader_objects = false;
#ifdef LOAD_ARB_shader_objects
PFNGLDELETEOBJECTARBPROC			glDeleteObjectARB			= 0;
PFNGLGETHANDLEARBPROC				glGetHandleARB				= 0;
PFNGLDETACHOBJECTARBPROC			glDetachObjectARB			= 0;
PFNGLCREATESHADEROBJECTARBPROC		glCreateShaderObjectARB		= 0;
PFNGLSHADERSOURCEARBPROC			glShaderSourceARB			= 0;
PFNGLCOMPILESHADERARBPROC			glCompileShaderARB			= 0;
PFNGLCREATEPROGRAMOBJECTARBPROC		glCreateProgramObjectARB	= 0;
PFNGLATTACHOBJECTARBPROC			glAttachObjectARB			= 0;
PFNGLLINKPROGRAMARBPROC				glLinkProgramARB			= 0;
PFNGLUSEPROGRAMOBJECTARBPROC		glUseProgramObjectARB		= 0;
PFNGLVALIDATEPROGRAMARBPROC			glValidateProgramARB		= 0;
PFNGLUNIFORM1FARBPROC				glUniform1fARB				= 0;
PFNGLUNIFORM2FARBPROC				glUniform2fARB				= 0;
PFNGLUNIFORM3FARBPROC				glUniform3fARB				= 0;
PFNGLUNIFORM4FARBPROC				glUniform4fARB				= 0;
PFNGLUNIFORM1IARBPROC				glUniform1iARB				= 0;
PFNGLUNIFORM2IARBPROC				glUniform2iARB				= 0;
PFNGLUNIFORM3IARBPROC				glUniform3iARB				= 0;
PFNGLUNIFORM4IARBPROC				glUniform4iARB				= 0;
PFNGLUNIFORM1FVARBPROC				glUniform1fvARB				= 0;
PFNGLUNIFORM2FVARBPROC				glUniform2fvARB				= 0;
PFNGLUNIFORM3FVARBPROC				glUniform3fvARB				= 0;
PFNGLUNIFORM4FVARBPROC				glUniform4fvARB				= 0;
PFNGLUNIFORM1IVARBPROC				glUniform1ivARB				= 0;
PFNGLUNIFORM2IVARBPROC				glUniform2ivARB				= 0;
PFNGLUNIFORM3IVARBPROC				glUniform3ivARB				= 0;
PFNGLUNIFORM4IVARBPROC				glUniform4ivARB				= 0;
PFNGLUNIFORMMATRIX2FVARBPROC		glUniformMatrix2fvARB		= 0;
PFNGLUNIFORMMATRIX3FVARBPROC		glUniformMatrix3fvARB		= 0;
PFNGLUNIFORMMATRIX4FVARBPROC		glUniformMatrix4fvARB		= 0;
PFNGLGETOBJECTPARAMETERFVARBPROC	glGetObjectParameterfvARB	= 0;
PFNGLGETOBJECTPARAMETERIVARBPROC	glGetObjectParameterivARB	= 0;
PFNGLGETINFOLOGARBPROC				glGetInfoLogARB				= 0;
PFNGLGETATTACHEDOBJECTSARBPROC		glGetAttachedObjectsARB		= 0;
PFNGLGETUNIFORMLOCATIONARBPROC		glGetUniformLocationARB		= 0;
PFNGLGETACTIVEUNIFORMARBPROC		glGetActiveUniformARB		= 0;
PFNGLGETUNIFORMFVARBPROC			glGetUniformfvARB			= 0;
PFNGLGETUNIFORMIVARBPROC			glGetUniformivARB			= 0;
PFNGLGETSHADERSOURCEARBPROC			glGetShaderSourceARB		= 0;
#endif //LOAD_ARB_shader_objects

bool found_GL_ARB_vertex_shader = false;
#ifdef LOAD_ARB_vertex_shader
PFNGLBINDATTRIBLOCATIONARBPROC		glBindAttribLocationARB		= 0;
PFNGLGETACTIVEATTRIBARBPROC			glGetActiveAttribARB		= 0;
PFNGLGETATTRIBLOCATIONARBPROC		glGetAttribLocationARB		= 0;
#endif

bool found_GL_ARB_vertex_program = false;
#ifdef LOAD_ARB_vertex_program
PFNGLVERTEXATTRIB1DARBPROC	glVertexAttrib1dARB = 0;
PFNGLVERTEXATTRIB1DVARBPROC	glVertexAttrib1dvARB = 0;
PFNGLVERTEXATTRIB1FARBPROC	glVertexAttrib1fARB = 0;
PFNGLVERTEXATTRIB1FVARBPROC	glVertexAttrib1fvARB = 0;
PFNGLVERTEXATTRIB1SARBPROC	glVertexAttrib1sARB = 0;
PFNGLVERTEXATTRIB1SVARBPROC	glVertexAttrib1svARB = 0;
PFNGLVERTEXATTRIB2DARBPROC	glVertexAttrib2dARB = 0;
PFNGLVERTEXATTRIB2DVARBPROC	glVertexAttrib2dvARB = 0;
PFNGLVERTEXATTRIB2FARBPROC	glVertexAttrib2fARB = 0;
PFNGLVERTEXATTRIB2FVARBPROC	glVertexAttrib2fvARB = 0;
PFNGLVERTEXATTRIB2SARBPROC	glVertexAttrib2sARB = 0;
PFNGLVERTEXATTRIB2SVARBPROC	glVertexAttrib2svARB = 0;
PFNGLVERTEXATTRIB3DARBPROC	glVertexAttrib3dARB = 0;
PFNGLVERTEXATTRIB3DVARBPROC	glVertexAttrib3dvARB = 0;
PFNGLVERTEXATTRIB3FARBPROC	glVertexAttrib3fARB = 0;
PFNGLVERTEXATTRIB3FVARBPROC	glVertexAttrib3fvARB = 0;
PFNGLVERTEXATTRIB3SARBPROC	glVertexAttrib3sARB = 0;
PFNGLVERTEXATTRIB3SVARBPROC	glVertexAttrib3svARB = 0;
PFNGLVERTEXATTRIB4NBVARBPROC	glVertexAttrib4NbvARB = 0;
PFNGLVERTEXATTRIB4NIVARBPROC	glVertexAttrib4NivARB = 0;
PFNGLVERTEXATTRIB4NSVARBPROC	glVertexAttrib4NsvARB = 0;
PFNGLVERTEXATTRIB4NUBARBPROC	glVertexAttrib4NubARB = 0;
PFNGLVERTEXATTRIB4NUBVARBPROC	glVertexAttrib4NubvARB = 0;
PFNGLVERTEXATTRIB4NUIVARBPROC	glVertexAttrib4NuivARB = 0;
PFNGLVERTEXATTRIB4NUSVARBPROC	glVertexAttrib4NusvARB = 0;
PFNGLVERTEXATTRIB4BVARBPROC	glVertexAttrib4bvARB = 0;
PFNGLVERTEXATTRIB4DARBPROC	glVertexAttrib4dARB = 0;
PFNGLVERTEXATTRIB4DVARBPROC	glVertexAttrib4dvARB = 0;
PFNGLVERTEXATTRIB4FARBPROC	glVertexAttrib4fARB = 0;
PFNGLVERTEXATTRIB4FVARBPROC	glVertexAttrib4fvARB = 0;
PFNGLVERTEXATTRIB4IVARBPROC	glVertexAttrib4ivARB = 0;
PFNGLVERTEXATTRIB4SARBPROC	glVertexAttrib4sARB = 0;
PFNGLVERTEXATTRIB4SVARBPROC	glVertexAttrib4svARB = 0;
PFNGLVERTEXATTRIB4UBVARBPROC	glVertexAttrib4ubvARB = 0;
PFNGLVERTEXATTRIB4UIVARBPROC	glVertexAttrib4uivARB = 0;
PFNGLVERTEXATTRIB4USVARBPROC	glVertexAttrib4usvARB = 0;
PFNGLVERTEXATTRIBPOINTERARBPROC	glVertexAttribPointerARB = 0;
PFNGLENABLEVERTEXATTRIBARRAYARBPROC	glEnableVertexAttribArrayARB = 0;
PFNGLDISABLEVERTEXATTRIBARRAYARBPROC	glDisableVertexAttribArrayARB = 0;
PFNGLPROGRAMSTRINGARBPROC	glProgramStringARB = 0;
PFNGLBINDPROGRAMARBPROC	glBindProgramARB = 0;
PFNGLDELETEPROGRAMSARBPROC	glDeleteProgramsARB = 0;
PFNGLGENPROGRAMSARBPROC	glGenProgramsARB = 0;
PFNGLPROGRAMENVPARAMETER4DARBPROC	glProgramEnvParameter4dARB = 0;
PFNGLPROGRAMENVPARAMETER4DVARBPROC	glProgramEnvParameter4dvARB = 0;
PFNGLPROGRAMENVPARAMETER4FARBPROC	glProgramEnvParameter4fARB = 0;
PFNGLPROGRAMENVPARAMETER4FVARBPROC	glProgramEnvParameter4fvARB = 0;
PFNGLPROGRAMLOCALPARAMETER4DARBPROC	glProgramLocalParameter4dARB = 0;
PFNGLPROGRAMLOCALPARAMETER4DVARBPROC	glProgramLocalParameter4dvARB = 0;
PFNGLPROGRAMLOCALPARAMETER4FARBPROC	glProgramLocalParameter4fARB = 0;
PFNGLPROGRAMLOCALPARAMETER4FVARBPROC	glProgramLocalParameter4fvARB = 0;
PFNGLGETPROGRAMENVPARAMETERDVARBPROC	glGetProgramEnvParameterdvARB = 0;
PFNGLGETPROGRAMENVPARAMETERFVARBPROC	glGetProgramEnvParameterfvARB = 0;
PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC	glGetProgramLocalParameterdvARB = 0;
PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC	glGetProgramLocalParameterfvARB = 0;
PFNGLGETPROGRAMIVARBPROC	glGetProgramivARB = 0;
PFNGLGETPROGRAMSTRINGARBPROC	glGetProgramStringARB = 0;
PFNGLGETVERTEXATTRIBDVARBPROC	glGetVertexAttribdvARB = 0;
PFNGLGETVERTEXATTRIBFVARBPROC	glGetVertexAttribfvARB = 0;
PFNGLGETVERTEXATTRIBIVARBPROC	glGetVertexAttribivARB = 0;
PFNGLGETVERTEXATTRIBPOINTERVARBPROC	glGetVertexAttribPointervARB = 0;
PFNGLISPROGRAMARBPROC	glIsProgramARB = 0;
#endif //LOAD_ARB_vertex_program


bool ShaderSystem::init(void) {
	int fail;

	//GL_ARB_shader_objects
#ifdef LOAD_ARB_shader_objects
	fail = load_ext("GL_ARB_shader_objects", 
		GLEXT_ECHOPARAM_ARB(glDeleteObject),
		GLEXT_ECHOPARAM_ARB(glGetHandle),
		GLEXT_ECHOPARAM_ARB(glDetachObject),
		GLEXT_ECHOPARAM_ARB(glCreateShaderObject),
		GLEXT_ECHOPARAM_ARB(glShaderSource),
		GLEXT_ECHOPARAM_ARB(glCompileShader),
		GLEXT_ECHOPARAM_ARB(glCreateProgramObject),
		GLEXT_ECHOPARAM_ARB(glAttachObject),
		GLEXT_ECHOPARAM_ARB(glLinkProgram),
		GLEXT_ECHOPARAM_ARB(glUseProgramObject),
		GLEXT_ECHOPARAM_ARB(glValidateProgram),
		GLEXT_ECHOPARAM_ARB(glUniform1f),
		GLEXT_ECHOPARAM_ARB(glUniform2f),
		GLEXT_ECHOPARAM_ARB(glUniform3f),
		GLEXT_ECHOPARAM_ARB(glUniform4f),
		GLEXT_ECHOPARAM_ARB(glUniform1i),
		GLEXT_ECHOPARAM_ARB(glUniform2i),
		GLEXT_ECHOPARAM_ARB(glUniform3i),
		GLEXT_ECHOPARAM_ARB(glUniform4i),
		GLEXT_ECHOPARAM_ARB(glUniform1fv),
		GLEXT_ECHOPARAM_ARB(glUniform2fv),
		GLEXT_ECHOPARAM_ARB(glUniform3fv),
		GLEXT_ECHOPARAM_ARB(glUniform4fv),
		GLEXT_ECHOPARAM_ARB(glUniform1iv),
		GLEXT_ECHOPARAM_ARB(glUniform2iv),
		GLEXT_ECHOPARAM_ARB(glUniform3iv),
		GLEXT_ECHOPARAM_ARB(glUniform4iv),
		GLEXT_ECHOPARAM_ARB(glUniformMatrix2fv),
		GLEXT_ECHOPARAM_ARB(glUniformMatrix3fv),
		GLEXT_ECHOPARAM_ARB(glUniformMatrix4fv),
		GLEXT_ECHOPARAM_ARB(glGetObjectParameterfv),
		GLEXT_ECHOPARAM_ARB(glGetObjectParameteriv),
		GLEXT_ECHOPARAM_ARB(glGetInfoLog),
		GLEXT_ECHOPARAM_ARB(glGetAttachedObjects),
		GLEXT_ECHOPARAM_ARB(glGetUniformLocation),
		GLEXT_ECHOPARAM_ARB(glGetActiveUniform),
		GLEXT_ECHOPARAM_ARB(glGetUniformfv),
		GLEXT_ECHOPARAM_ARB(glGetUniformiv),
		GLEXT_ECHOPARAM_ARB(glGetShaderSource),
		NULL);
	if (fail == -1) {
		found_GL_ARB_shader_objects = true;
		cerr << "found GL extension GL_ARB_shader_objects" << endl;
	} else {
		cerr << "couldnt find GL extension GL_ARB_shader_objects" << endl;
		cerr << "failed on entry " << fail << endl;
		return false;
	}
#else //LOAD_ARB_shader_objects
	found_GL_ARB_shader_objects = true;
#endif //LOAD_ARB_shader_objects

	//GL_ARB_vertex_program
#ifdef LOAD_ARB_vertex_program
	fail = load_ext("GL_ARB_vertex_program", 
		GLEXT_ECHOPARAM(glVertexAttrib1dARB),
		GLEXT_ECHOPARAM(glVertexAttrib1dvARB),
		GLEXT_ECHOPARAM(glVertexAttrib1fARB),
		GLEXT_ECHOPARAM(glVertexAttrib1fvARB),
		GLEXT_ECHOPARAM(glVertexAttrib1sARB),
		GLEXT_ECHOPARAM(glVertexAttrib1svARB),
		GLEXT_ECHOPARAM(glVertexAttrib2dARB),
		GLEXT_ECHOPARAM(glVertexAttrib2dvARB),
		GLEXT_ECHOPARAM(glVertexAttrib2fARB),
		GLEXT_ECHOPARAM(glVertexAttrib2fvARB),
		GLEXT_ECHOPARAM(glVertexAttrib2sARB),
		GLEXT_ECHOPARAM(glVertexAttrib2svARB),
		GLEXT_ECHOPARAM(glVertexAttrib3dARB),
		GLEXT_ECHOPARAM(glVertexAttrib3dvARB),
		GLEXT_ECHOPARAM(glVertexAttrib3fARB),
		GLEXT_ECHOPARAM(glVertexAttrib3fvARB),
		GLEXT_ECHOPARAM(glVertexAttrib3sARB),
		GLEXT_ECHOPARAM(glVertexAttrib3svARB),
		GLEXT_ECHOPARAM(glVertexAttrib4NbvARB),
		GLEXT_ECHOPARAM(glVertexAttrib4NivARB),
		GLEXT_ECHOPARAM(glVertexAttrib4NsvARB),
		GLEXT_ECHOPARAM(glVertexAttrib4NubARB),
		GLEXT_ECHOPARAM(glVertexAttrib4NubvARB),
		GLEXT_ECHOPARAM(glVertexAttrib4NuivARB),
		GLEXT_ECHOPARAM(glVertexAttrib4NusvARB),
		GLEXT_ECHOPARAM(glVertexAttrib4bvARB),
		GLEXT_ECHOPARAM(glVertexAttrib4dARB),
		GLEXT_ECHOPARAM(glVertexAttrib4dvARB),
		GLEXT_ECHOPARAM(glVertexAttrib4fARB),
		GLEXT_ECHOPARAM(glVertexAttrib4fvARB),
		GLEXT_ECHOPARAM(glVertexAttrib4ivARB),
		GLEXT_ECHOPARAM(glVertexAttrib4sARB),
		GLEXT_ECHOPARAM(glVertexAttrib4svARB),
		GLEXT_ECHOPARAM(glVertexAttrib4ubvARB),
		GLEXT_ECHOPARAM(glVertexAttrib4uivARB),
		GLEXT_ECHOPARAM(glVertexAttrib4usvARB),
		GLEXT_ECHOPARAM(glVertexAttribPointerARB),
		GLEXT_ECHOPARAM(glEnableVertexAttribArrayARB),
		GLEXT_ECHOPARAM(glDisableVertexAttribArrayARB),
		GLEXT_ECHOPARAM(glProgramStringARB),
		GLEXT_ECHOPARAM(glBindProgramARB),
		GLEXT_ECHOPARAM(glDeleteProgramsARB),
		GLEXT_ECHOPARAM(glGenProgramsARB),
		GLEXT_ECHOPARAM(glProgramEnvParameter4dARB),
		GLEXT_ECHOPARAM(glProgramEnvParameter4dvARB),
		GLEXT_ECHOPARAM(glProgramEnvParameter4fARB),
		GLEXT_ECHOPARAM(glProgramEnvParameter4fvARB),
		GLEXT_ECHOPARAM(glProgramLocalParameter4dARB),
		GLEXT_ECHOPARAM(glProgramLocalParameter4dvARB),
		GLEXT_ECHOPARAM(glProgramLocalParameter4fARB),
		GLEXT_ECHOPARAM(glProgramLocalParameter4fvARB),
		GLEXT_ECHOPARAM(glGetProgramEnvParameterdvARB),
		GLEXT_ECHOPARAM(glGetProgramEnvParameterfvARB),
		GLEXT_ECHOPARAM(glGetProgramLocalParameterdvARB),
		GLEXT_ECHOPARAM(glGetProgramLocalParameterfvARB),
		GLEXT_ECHOPARAM(glGetProgramivARB),
		GLEXT_ECHOPARAM(glGetProgramStringARB),
		GLEXT_ECHOPARAM(glGetVertexAttribdvARB),
		GLEXT_ECHOPARAM(glGetVertexAttribfvARB),
		GLEXT_ECHOPARAM(glGetVertexAttribivARB),
		GLEXT_ECHOPARAM(glGetVertexAttribPointervARB),
		GLEXT_ECHOPARAM(glIsProgramARB),
		NULL);
	if (fail == -1) {
		found_GL_ARB_vertex_program = true;
		cerr << "found GL extension GL_ARB_vertex_program" << endl;
	} else {
		cerr << "couldnt find GL extension GL_ARB_vertex_program" << endl;
		cerr << "failed on entry " << fail << endl;
	}
#else	//LOAD_ARB_vertex_program
	found_GL_ARB_vertex_program = true;
#endif	//LOAD_ARB_vertex_program

#ifdef LOAD_ARB_vertex_shader
	fail = load_ext("GL_ARB_vertex_shader", 
		GLEXT_ECHOPARAM(glBindAttribLocationARB),
		GLEXT_ECHOPARAM(glGetActiveAttribARB),
		GLEXT_ECHOPARAM(glGetAttribLocationARB),
		NULL);
	if (fail == -1) {
		found_GL_ARB_vertex_shader = true;
		cerr << "found GL extension found_GL_ARB_vertex_shader" << endl;
	} else {
		cerr << "couldnt find GL extension found_GL_ARB_vertex_shader" << endl;
		cerr << "failed on entry " << fail << endl;
	}
#else	//LOAD_ARB_vertex_shader
	found_GL_ARB_vertex_shader = true;
#endif	//LOAD_ARB_vertex_shader

	return true;
}

//singleton
ShaderSystem shaderSystem;
